#include <cstrike>
#include <multicolors>
#include <autoexecconfig>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

public Plugin myinfo = 
{
	name = "Join Team Message", 
	author = "Kent", 
	description = "Join Team Message", 
	version = "1.0", 
	url = "https://www.mortall.ro"
};

//CONVARS

ConVar gConVar_Prefix;

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

public void OnPluginStart()
{
	//TRANSLATIONS
	LoadTranslations("jointeammessage.phrases");
	
	//REMOVE DEFAULT MESSAGES
	HookEvent("player_team", OnPlayerTeam, EventHookMode_Pre);
	
	//CONVARS
	AutoExecConfig_SetFile("plugin.jointeammessage");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_jointeammessage_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	gConVar_Prefix = AutoExecConfig_CreateConVar("sm_jointeammessage_prefix", "1", "Enable/Disable Prefix of Chat Messages (0 - Disable | 1 - Enable)", 0, true, 0.0, true, 3.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//WHEN SOMEONE CHANGE TEAM
	AddCommandListener(Listener_JoinTeam, "jointeam");
}

//PREFIX

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//REMOVE DEFAULT MESSAGES

public Action OnPlayerTeam(Event event, const char[] command, bool dontBroadcast)
{
	return (Plugin_Handled);
}

//PLUGIN

public Action Listener_JoinTeam(int client, const char[] command, int args)
{
	CreateTimer(0.1, Timer_DelayTeam3, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
}

public Action Timer_DelayTeam3(Handle timer, any data)
{
	int client = GetClientOfUserId(data);
	
	char name[100];
	GetClientName(client, name, sizeof(name));
	
	if (IsValidClient(client))
	{
		if (GetClientTeam(client) == CS_TEAM_CT)
		{
			if (gConVar_Prefix.BoolValue)
			{
				char joinctmessage[MAX_NAME_LENGTH + 32];
				Format(joinctmessage, sizeof(joinctmessage), "%s %t", g_ChatPrefix, "Join CT Message", name);
				
				CPrintToChatAll(joinctmessage);
			}
			else
			{
				char joinctmessage1[MAX_NAME_LENGTH + 32];
				Format(joinctmessage1, sizeof(joinctmessage1), "%t", "Join CT Message", name);
				
				CPrintToChatAll(joinctmessage1);
			}
		}
		else if (GetClientTeam(client) == CS_TEAM_T)
		{
			if (gConVar_Prefix.BoolValue)
			{
				char jointmessage[MAX_NAME_LENGTH + 32];
				Format(jointmessage, sizeof(jointmessage), "%s %t", g_ChatPrefix, "Join T Message", name);
				
				CPrintToChatAll(jointmessage);
			}
			else
			{
				char jointmessage1[MAX_NAME_LENGTH + 32];
				Format(jointmessage1, sizeof(jointmessage1), "%t", "Join T Message", name);
				
				CPrintToChatAll(jointmessage1);
			}
		}
	}
}

stock bool IsValidClient(int client)
{
	return client > 0 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && !IsFakeClient(client);
} 